/* ==================================================================
   File: ProgrammerAids.h

   This file provides functions that are useful across all of the
   program files.

            Copyright (C) 2014 Richard C. Wagner
   This file is offered under the GNU General Public License.
   Please see the license statement at the end of the file.
   =============================================================== */

double pi = 3.14159265359;

double RadiansToDegrees (double Radians)
{
    return (Radians / 2.0 / pi) * 360.0;
}

double DegreesToRadians (double Degrees)
{
    return (Degrees / 360.0) * 2.0 * pi;
}

double FtPerSecToKts (double FtPerSec)
{
    return (FtPerSec / 6080.0 ) * 3600.0;
}

double KtsToFtPerSec (double Kts)
{
    return (Kts * 6080.0) / 3600.0;
}

double PowerToHP (double FtLbPerSec)
{
    return (FtLbPerSec/550.0);
}


/* ====================  License Statement  =========================
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.
   =============================================================== */
