\ ===================================================================
\  File: Client-GUI.FTH
\
\  This file comprises the Windows GUI for the simulation client.
\  It's constructed using a main window and the MPE resource words.
\  The best reference for the code included here is probably Petzold's
\  "Programming Windows", along with the Microsoft Developer's Network,
\  at      http://msdn.microsoft.com/en-us/windows/desktop
\  Enter any Windows function call you see here, in the search field
\  at the upper-right of the web page.
\
\              Copyright (C) 2014 Richard C. Wagner
\  This file is offered under the GNU General Public License.
\  Please see the license statement at the end of the file.
\ ===================================================================

\ ============================  Menu  ===============================

NextID: IDM_MENU
NextID: IDM_ABOUT

IDM_Menu MENU
BEGIN
   MENUITEM " About", IDM_ABOUT
END


\ ===============  Main Window Resource Template  ===================

NextID: IDW_MAINWINDOW

\ Create a main window template.
IDW_MAINWINDOW WINDOW 200, 100, 545, 475
BEGIN
   Caption         " Multi-Sim Open-Loop Cab"
   Style           WS_OVERLAPPEDWINDOW | WS_VISIBLE
   ClassStyle      CS_HREDRAW | CS_VREDRAW
   Icon            IDI_APPLICATION
   Cursor          IDC_ARROW
   Brush           WHITE_BRUSH
   Menu            IDM_MENU
   WndProc         PROCESS-EVENT
END


\ ==============  About Dialog Box Resource Template ================

NextID: IDD_ABOUTDIALOG

IDD_ABOUTDIALOG DIALOG DISCARDABLE 40, 20, 220, 135
STYLE DS_MODALFRAME | WS_SYSMENU | DS_3DLOOK
FONT 9, 0, 0 "Arial"
BEGIN
   CTEXT  "Multi-Sim Open-Loop Cab -- v1.0",                               IDC_STATIC,  0,  5, 220, 10
   CTEXT  "Copyright (C) Richard C. Wagner, 2014",                         IDC_STATIC,  0, 20, 220, 10
   CTEXT  "www.radicalnovelties.com/multi-sim/multi-sim.html",             IDC_STATIC,  0, 40, 220, 10
   CTEXT  "Contact: multi-sim@radicalnovelties.com",                       IDC_STATIC,  0, 50, 220, 10
   CTEXT  "This program is offered under the GNU General Public License.", IDC_STATIC,  0, 70, 220, 10
   CTEXT  "See the file 'GNU Public License 3-0.txt', included in this",   IDC_STATIC,  0, 80, 220, 10
   CTEXT  "package for details.  Or see: http://www.gnu.org/licenses/",    IDC_STATIC,  0, 90, 220, 10
   DEFPUSHBUTTON "OK",                                                     IDOK,       90, 105, 50, 14
END

4 1 CALLBACK: AboutDialogProc


\ =====================  Static Text Fields  ========================

249 VALUE RED
249 VALUE GREEN
249 VALUE BLUE

\ A brush handle for the static text background
0 VALUE hBRUSH_STATIC

: CREATE-STATIC-BRUSH ( -- )   RED GREEN BLUE RGB CreateSolidBrush
   TO hBRUSH_STATIC ;

: SET-STATIC-COLOR ( hDC -- )   RED GREEN BLUE RGB SetBKColor DROP ;

\ --- Static field data linked-list ---
STRUCT STATIC-VALUES ( -- N )
   CELL FIELD SF-LINK
   CELL FIELD SF-ID
   CELL FIELD hSF
END-STRUCT

VARIABLE LAST-STATICFIELD
0 LAST-STATICFIELD !

: LINK-STATICFIELD ( nID,hWND -- )   HERE >R STATIC-VALUES ALLOT&ERASE
   R@ hSF ! R@ SF-ID ! LAST-STATICFIELD @ R@ SF-LINK !
   R> LAST-STATICFIELD ! ;

: sfID>hSF ( nID -- hPB )   LAST-STATICFIELD @
   BEGIN
      DUP 0= IF DROP EXIT THEN
      2DUP SF-ID @ = IF NIP hSF @ EXIT THEN
      SF-LINK @
   AGAIN ;

: CREATE-STATIC-FIELD ( nID,a$z,hWND,X,Y -- )
   { nID a$z hWND X Y }
   NULL
   Z" static"
   a$z
   WS_CHILD WS_VISIBLE OR
   X Y a$z ZSTRLEN WTEXT * HTEXT
   hWND
   nID
   hWND GWL_HINSTANCE GetWindowLong
   NULL
   CreateWindowEx nID SWAP LINK-STATICFIELD ;

\ Display the string a$z in field nID
: .SF ( a$z,nID -- )   sfID>hSF SWAP SetWindowText DROP ;


\ =====================  Pushbutton Controls  =======================

\ Pushbutton metrics
HTEXT 7 * 4 / VALUE PBHEIGHT
150           VALUE PBWIDTH
PBHEIGHT 4 +  VALUE PBVPITCH
10            VALUE PBVMARGIN

\ Takes number in stack and returns Y position
: PBY ( # -- Y )   PBVPITCH * PBVMARGIN + ;

\ --- Pushbutton data linked-list ---
STRUCT BUTTON-VALUES ( -- N )
   CELL FIELD PB-LINK
   CELL FIELD PB-ID
   CELL FIELD hPB
   CELL FIELD PB-NAME$
   CELL FIELD PB-X
   CELL FIELD PB-Y
END-STRUCT

VARIABLE LAST-PUSHBUTTON
0 LAST-PUSHBUTTON !

: LINK-PUSHBUTTON ( nID,hWND -- )   HERE >R BUTTON-VALUES ALLOT&ERASE
   R@ hPB ! R@ PB-ID ! LAST-PUSHBUTTON @ R@ PB-LINK !
   R> LAST-PUSHBUTTON ! ;

: >PUSHBUTTON ( nID -- a )   LAST-PUSHBUTTON @
   BEGIN
      DUP 0= IF DROP EXIT THEN
      2DUP PB-ID @ = IF NIP EXIT THEN
      PB-LINK @
   AGAIN ;

: pbID>hPB ( nID -- hPB )   >PUSHBUTTON hPB @ ;

: ENABLE-PUSHBUTTON ( nID -- )   pbID>hPB TRUE EnableWindow DROP ;

: DISABLE-PUSHBUTTON ( nID -- )   pbID>hPB FALSE EnableWindow DROP ;

: ENABLE-PUSHBUTTONS ( -- )   LAST-PUSHBUTTON @
   BEGIN DUP 0<> WHILE DUP PB-ID @ ENABLE-PUSHBUTTON PB-LINK @ REPEAT DROP ;

: DISABLE-PUSHBUTTONS ( -- )   LAST-PUSHBUTTON @
   BEGIN DUP 0<> WHILE DUP PB-ID @ DISABLE-PUSHBUTTON PB-LINK @ REPEAT DROP ;

: CREATE-PUSHBUTTON ( nID,aZname,hWND,X,Y -- )
   { ID aZname hWND X Y }           \ Make named locals
   NULL
   Z" button"
   aZname
   WS_CHILD WS_VISIBLE OR BS_PUSHBUTTON OR
   X Y PBWIDTH PBHEIGHT
   hWND
   ID
   hWND GWL_HINSTANCE GetWindowLong
   NULL
   CreateWindowEx ID OVER LINK-PUSHBUTTON
   FALSE EnableWindow DROP
   X ID >PUSHBUTTON PB-X !  Y ID >PUSHBUTTON PB-Y !
   aZname ID >PUSHBUTTON PB-NAME$ ! ;


\ ====================  Pushbutton Definitions  =====================

NextID: IDB_CONNECT
NextID: IDB_TRIMALPHA
NextID: IDB_TRIMSPEED
NextID: IDB_TRIMDELE
NextID: IDB_S/L
NextID: IDB_STICKRAP
NextID: IDB_ELEVATORDOUBLET
NextID: IDB_AILERONDOUBLET
NextID: IDB_RUDDERDOUBLET
NextID: IDB_LOOP
NextID: IDB_AILERONROLL

: CREATE-PUSHBUTTONS ( hWND -- )   >R
   IDB_CONNECT         Z" Connect to Server" R@ 20  10    CREATE-PUSHBUTTON
   IDB_TRIMALPHA       Z" Trim by Alpha"     R@ 20  3 PBY CREATE-PUSHBUTTON
   IDB_TRIMSPEED       Z" Trim by Speed"     R@ 20  4 PBY CREATE-PUSHBUTTON
   IDB_TRIMDELE        Z" Trim by Del-E"     R@ 20  5 PBY CREATE-PUSHBUTTON
   IDB_S/L             Z" No Control Input"  R@ 360 3 PBY CREATE-PUSHBUTTON
   IDB_STICKRAP        Z" Stick Rap"         R@ 360 4 PBY CREATE-PUSHBUTTON
   IDB_ELEVATORDOUBLET Z" Elevator Doublet"  R@ 360 5 PBY CREATE-PUSHBUTTON
   IDB_AILERONDOUBLET  Z" Aileron Doublet"   R@ 360 6 PBY CREATE-PUSHBUTTON
   IDB_RUDDERDOUBLET   Z" Rudder Doublet"    R@ 360 7 PBY CREATE-PUSHBUTTON
   IDB_LOOP            Z" Loop"              R@ 360 8 PBY CREATE-PUSHBUTTON
   IDB_AILERONROLL     Z" Aileron Roll"      R> 360 9 PBY CREATE-PUSHBUTTON
   IDB_CONNECT ENABLE-PUSHBUTTON ;

: ENABLE-TRIM-BUTTONS ( -- )
   IDB_TRIMALPHA ENABLE-PUSHBUTTON
   IDB_TRIMSPEED ENABLE-PUSHBUTTON
   IDB_TRIMDELE  ENABLE-PUSHBUTTON ;

: ENABLE-FLY-BUTTONS ( -- )
   IDB_S/L             ENABLE-PUSHBUTTON
   IDB_STICKRAP        ENABLE-PUSHBUTTON
   IDB_ELEVATORDOUBLET ENABLE-PUSHBUTTON
   IDB_AILERONDOUBLET  ENABLE-PUSHBUTTON
   IDB_RUDDERDOUBLET   ENABLE-PUSHBUTTON
   IDB_LOOP            ENABLE-PUSHBUTTON
   IDB_AILERONROLL     ENABLE-PUSHBUTTON ;

: DISABLE-FLY-BUTTONS ( -- )
   IDB_S/L             DISABLE-PUSHBUTTON
   IDB_STICKRAP        DISABLE-PUSHBUTTON
   IDB_ELEVATORDOUBLET DISABLE-PUSHBUTTON
   IDB_AILERONDOUBLET  DISABLE-PUSHBUTTON
   IDB_RUDDERDOUBLET   DISABLE-PUSHBUTTON
   IDB_LOOP            DISABLE-PUSHBUTTON
   IDB_AILERONROLL     DISABLE-PUSHBUTTON ;


\ =======================  Edit Fields  =============================

\ A temporary text buffer
100 CONSTANT EFBUFFERSIZE
EFBUFFERSIZE BUFFER: EFBUFFER

\ Edit field metrics
HTEXT 4 + VALUE EFHEIGHT
100       VALUE EFWIDTH
5         VALUE EFPAD

\ --- Edit field data linked-list ---
STRUCT EDIT-VALUES ( -- N )
   CELL FIELD EF-LINK
   CELL FIELD EF-ID
   CELL FIELD hEF
END-STRUCT

VARIABLE LAST-EDITFIELD
0 LAST-EDITFIELD !

: LINK-EDITFIELD ( nID,hWND -- )   HERE >R EDIT-VALUES ALLOT&ERASE
   R@ hEF ! R@ EF-ID ! LAST-EDITFIELD @ R@ EF-LINK !
   R> LAST-EDITFIELD ! ;

: efID>hEF ( nID -- hPB )   LAST-EDITFIELD @
   BEGIN
      DUP 0= IF DROP EXIT THEN
      2DUP EF-ID @ = IF NIP hEF @ EXIT THEN
      EF-LINK @
   AGAIN ;

: FCONVERT ( hWND,a -- r )   FNUMBER?
   CASE
       0  OF Z" Please enter only numbers." Z" Error" MB_OK MessageBox DROP
             0.0 ENDOF
       1  OF S>F DROP ENDOF
       2  OF D>F DROP ENDOF
      -2  OF     DROP ENDOF
   ENDCASE ;

: EF-F@ ( hWND,nID -- r )   efID>hEF EFBUFFER 1+ EFBUFFERSIZE 1-
   GetWindowText EFBUFFER C!  EFBUFFER FCONVERT ;

: EF-F! ( nID,r -- )   efID>hEF 3 (F.) TUCK EFBUFFER SWAP CMOVE
   0 SWAP EFBUFFER + C! EFBUFFER SetWindowText DROP ;

: CREATE-EDIT-FIELD ( nID,aZ$value,hWND,X,Y -- )
   { nID aZ$value hWND X Y }
   NULL
   Z" edit"
   aZ$value
   WS_CHILD WS_VISIBLE OR WS_BORDER OR ES_CENTER OR ES_AUTOHSCROLL OR
   X Y EFWIDTH EFHEIGHT
   hWND
   nID
   hWND GWL_HINSTANCE GetWindowLong
   NULL
   CreateWindowEx nID SWAP LINK-EDITFIELD ;


\ ====================  Trim Value Edit Fields  =====================
\  These fields "travel" with their respective pushbuttons.
\ ===================================================================

\ Takes pushbutton ID and returns the location of its edit field
: EDIT-LOC ( nID -- X,Y )   >PUSHBUTTON DUP PB-X @ PBWIDTH + EFPAD +
   SWAP PB-Y @ PBHEIGHT EFHEIGHT - 2/ + ;

NextID: IDEF_SERVERFIELD
NextID: IDEF_ALPHAFIELD
NextID: IDEF_SPEEDFIELD
NextID: IDEF_DELEFIELD

: CREATE-EDIT-FIELDS ( hWND -- )   >R
   IDEF_SERVERFIELD SERVER$ R@ IDB_CONNECT   EDIT-LOC CREATE-EDIT-FIELD
   IDEF_ALPHAFIELD  Z" 0.0" R@ IDB_TRIMALPHA EDIT-LOC CREATE-EDIT-FIELD
   IDEF_SPEEDFIELD  Z" 0.0" R@ IDB_TRIMSPEED EDIT-LOC CREATE-EDIT-FIELD
   IDEF_DELEFIELD   Z" 0.0" R> IDB_TRIMDELE  EDIT-LOC CREATE-EDIT-FIELD ;

\ Takes a pushbutton ID and returns the location of the edit label
: LABEL-LOC ( nID -- X,Y )   EDIT-LOC SWAP EFWIDTH + 5 + SWAP
   EFHEIGHT HTEXT - 2/ + ;

NextID: IDEL_SERVERLABEL
NextID: IDEL_ALPHALABEL
NextID: IDEL_SPEEDLABEL
NextID: IDEL_DELELABEL

: CREATE-EDIT-LABELS ( hWND -- )   >R
   IDEL_SERVERLABEL Z" IP address" R@ IDB_CONNECT   LABEL-LOC CREATE-STATIC-FIELD
   IDEL_ALPHALABEL  Z" deg."       R@ IDB_TRIMALPHA LABEL-LOC CREATE-STATIC-FIELD
   IDEL_SPEEDLABEL  Z" kts."       R@ IDB_TRIMSPEED LABEL-LOC CREATE-STATIC-FIELD
   IDEL_DELELABEL   Z" deg."       R> IDB_TRIMDELE  LABEL-LOC CREATE-STATIC-FIELD ;

: CREATE-EDIT-FIELDS&LABELS ( hWND -- )   DUP CREATE-EDIT-FIELDS
   CREATE-EDIT-LABELS ;


\ ======================  Trim data display  ========================

\ --- These words display their data in the trim EDIT fields. ---

: .TRIM-ALPHA ( -- )   TRIM-RESPONSE TR-ALPHA DF@ RAD>DEG
   IDEF_ALPHAFIELD EF-F! ;

: .TRIM-SPEED ( -- )   TRIM-RESPONSE TR-SPEED DF@ 6080.0 F/ 3600.0 F*
   IDEF_SPEEDFIELD EF-F! ;

: .TRIM-DELE ( -- )   TRIM-RESPONSE TR-DELE DF@ RAD>DEG
   IDEF_DELEFIELD EF-F! ;


\ --- These words display their data in the trim STATIC fields. ---

: TRIM-ORIGIN ( -- X,Y )   IDB_TRIMDELE >PUSHBUTTON
   DUP PB-X @ PBWIDTH + EFPAD +   SWAP PB-Y @ PBVPITCH + ;

HTEXT 4 + VALUE TRIM-INC

: TLINE ( N -- X,Y )   TRIM-ORIGIN ROT TRIM-INC * + ;

: ZT$ ( -- a$z )   Z" 00000000000000000" ;


\ Static trim field IDs
NextID: IDSF_TRIMSTATE
NextID: IDSF_TRIMBETA
NextID: IDSF_TRIMDELA
NextID: IDSF_TRIMDELR
NextID: IDSF_TRIMPOWER
NextID: IDSF_TRIMTHROTTLE

: CREATE-TRIM-FIELDS ( hWND -- )   >R
   IDSF_TRIMSTATE    ZT$ R@ TRIM-ORIGIN DROP 85 CREATE-STATIC-FIELD
   IDSF_TRIMBETA     ZT$ R@ 0 TLINE             CREATE-STATIC-FIELD
   IDSF_TRIMDELA     ZT$ R@ 1 TLINE             CREATE-STATIC-FIELD
   IDSF_TRIMDELR     ZT$ R@ 2 TLINE             CREATE-STATIC-FIELD
   IDSF_TRIMPOWER    ZT$ R@ 3 TLINE             CREATE-STATIC-FIELD
   IDSF_TRIMTHROTTLE ZT$ R> 4 TLINE             CREATE-STATIC-FIELD ;


\ --- These words assemble zero-terminated trim strings. ---

100 BUFFER: TRIM-BUFFER

: !ZT ( a$z -- )   TRIM-BUFFER ZMOVE ;
: +ZF ( r -- )   3 (F.) TRIM-BUFFER APPENDZ ;
: +ZDEG ( -- )   Z"  deg." TRIM-BUFFER Z$+ ;
: +ZKTS ( -- )   Z"  kts." TRIM-BUFFER Z$+ ;
: +ZLB ( -- )   Z"  lb." TRIM-BUFFER Z$+ ;
: +ZHP ( -- )   Z"  HP." TRIM-BUFFER Z$+ ;
: +Z% ( -- )   Z" %" TRIM-BUFFER Z$+ ;

: Z-TRIM-STATE ( -- )   TRIM-RESPONSE TR-TRIM-RESULT @(N)
   IF Z"      Trimmed" ELSE Z" > UNTRIMMED <" THEN !ZT ;

: Z-TRIM-BETA ( -- )   Z" Beta = " !ZT
   TRIM-RESPONSE TR-BETA DF@ RAD>DEG +ZF +ZDEG ;

: Z-TRIM-DELA ( -- )   Z" Delta A = " !ZT
   TRIM-RESPONSE TR-DELA DF@ RAD>DEG +ZF +ZDEG ;

: Z-TRIM-DELR ( -- )   Z" Delta R = " !ZT
   TRIM-RESPONSE TR-DELR DF@ RAD>DEG +ZF +ZDEG ;

: Z-TRIM-POWER ( -- )   Z" Power = " !ZT
   TRIM-RESPONSE TR-POWER DF@ 550.0 F/ +ZF +ZHP ;

: Z-TRIM-THROTTLE ( -- )   Z" Throttle = " !ZT
   TRIM-RESPONSE TR-THROTTLE DF@ 100.0 F* +ZF +Z% ;

: UPDATE-TRIM-FIELDS ( -- )   .TRIM-ALPHA  .TRIM-SPEED  .TRIM-DELE
   Z-TRIM-STATE    TRIM-BUFFER IDSF_TRIMSTATE    .SF
   Z-TRIM-BETA     TRIM-BUFFER IDSF_TRIMBETA     .SF
   Z-TRIM-DELA     TRIM-BUFFER IDSF_TRIMDELA     .SF
   Z-TRIM-DELR     TRIM-BUFFER IDSF_TRIMDELR     .SF
   Z-TRIM-POWER    TRIM-BUFFER IDSF_TRIMPOWER    .SF
   Z-TRIM-THROTTLE TRIM-BUFFER IDSF_TRIMTHROTTLE .SF ;


\ ==================  Position Value Edit Fields  ===================

: PVE-ORIGIN ( -- X,Y )   5 TLINE 5 + ;

HTEXT 8 + CONSTANT PV-HEIGHT
WTEXT 9 * CONSTANT PVLABEL-WIDTH

: PVELOC ( N -- X,Y )   PVE-ORIGIN ROT PV-HEIGHT * + ;
: PVLLOC ( N -- X,Y )   PVELOC >R PVLABEL-WIDTH - R> ;
: PVULOC ( N -- X,Y )   PVELOC >R EFWIDTH + EFPAD + R> ;

NextID: IDEF_XPOSFIELD
NextID: IDEF_YPOSFIELD
NextID: IDEF_ALTFIELD
NextID: IDEF_PSIFIELD

NextID: IDSF_XPOSLABEL
NextID: IDSF_YPOSLABEL
NextID: IDSF_ALTLABEL
NextID: IDSF_PSILABEL
NextID: IDSF_XPOSUNIT
NextID: IDSF_YPOSUNIT
NextID: IDSF_ALTUNIT
NextID: IDSF_PSIUNIT

: CREATE-POSITION-LABELS ( hWND -- )   >R
   IDSF_XPOSLABEL Z" X-position" R@ 0 PVLLOC CREATE-STATIC-FIELD
   IDSF_YPOSLABEL Z" Y-position" R@ 1 PVLLOC CREATE-STATIC-FIELD
   IDSF_ALTLABEL  Z" Altitude"   R@ 2 PVLLOC CREATE-STATIC-FIELD
   IDSF_PSILABEL  Z" Bearing"    R> 3 PVLLOC CREATE-STATIC-FIELD ;

: CREATE-POSITION-FIELDS ( hWND -- )   >R
   IDEF_XPOSFIELD Z" 0.0" R@ 0 PVELOC CREATE-EDIT-FIELD
   IDEF_YPOSFIELD Z" 0.0" R@ 1 PVELOC CREATE-EDIT-FIELD
   IDEF_ALTFIELD  Z" 0.0" R@ 2 PVELOC CREATE-EDIT-FIELD
   IDEF_PSIFIELD  Z" 0.0" R> 3 PVELOC CREATE-EDIT-FIELD ;

: CREATE-POSITION-UNITS ( hWND -- )   >R
   IDSF_XPOSUNIT Z" ft."  R@ 0 PVULOC CREATE-STATIC-FIELD
   IDSF_YPOSUNIT Z" ft."  R@ 1 PVULOC CREATE-STATIC-FIELD
   IDSF_ALTUNIT  Z" ft."  R@ 2 PVULOC CREATE-STATIC-FIELD
   IDSF_PSIUNIT  Z" deg." R> 3 PVULOC CREATE-STATIC-FIELD ;

: CREATE-POSITION-FIELDS&LABELS ( hWND -- )   DUP CREATE-POSITION-LABELS
   DUP CREATE-POSITION-FIELDS  CREATE-POSITION-UNITS ;


\ =======================  Group Boxes  =============================

: CREATE-GROUP-BOX ( nID,a$z,hWND,X,Y,H,W -- hGB )
   { nID a$z hWND X Y H W }
   NULL
   Z" button"
   a$z
   WS_CHILD WS_VISIBLE OR BS_GROUPBOX OR
   X Y H W
   hWND
   nID
   hWND GWL_HINSTANCE GetWindowLong
   NULL
   CreateWindowEx ;


\ --- Trim Group Box ---

NextID: IDGB_TRIM
0 VALUE hGB_TRIM

: CREATE-TRIM-BOX ( hWND -- )   >R
   IDGB_TRIM Z" Trimming" R>
   10 2 PBY 10 -                       \ Upper-left corner loc
   IDB_TRIMALPHA LABEL-LOC DROP 40 +   \ Width
   3 PVULOC NIP 5 1 PBY NIP - 5 +      \ Height
   CREATE-GROUP-BOX TO hGB_TRIM ;


\ --- Flying Group Box ---

NextID: IDGB_FLYING
0 VALUE hGB_FLYING

: CREATE-FLYING-BOX ( hWND -- )   >R
   IDGB_FLYING Z" Flying" R>
   350 2 PBY 10 -                     \ Upper-left corner loc
   PBWIDTH 20 +                       \ Width
   10 PBY 2 PBY - 20 +                    \ Height
   CREATE-GROUP-BOX TO hGB_FLYING ;


\ =================  Top-Level Application Words  ===================

\ --- Setting/restoring pushbutton strings ---

: SET-BUTTON$ ( a$z,nID -- )   pbID>hPB SWAP SetWindowText DROP ;

: SET-WORKING$ ( nID -- )   Z" Working..." SWAP SET-BUTTON$ ;

: SET-CONNECTING$ ( -- )   Z" Connecting..." IDB_CONNECT SET-BUTTON$ ;

: SET-DISCONNECT$ ( -- )   Z" Disconnect" IDB_CONNECT SET-BUTTON$ ;

: RESTORE-BUTTON$ ( nID -- )   DUP >PUSHBUTTON PB-NAME$ @
   SWAP SET-BUTTON$ ;


\ --- Connecting to/disconnecting from the simulation ---

VARIABLE CONNECTED

: SET-IPADDR ( -- )   IDEF_SERVERFIELD efID>hEF EFBUFFER
   EFBUFFERSIZE GetWindowText EFBUFFER SWAP SERVER$ ZPLACE ;

: CONNECT>SERVER ( -- )   SET-CONNECTING$
   SET-IPADDR MAKE-CONNECTION DUP CONNECTED !
   IF   SET-DISCONNECT$ ENABLE-TRIM-BUTTONS
   ELSE IDB_CONNECT RESTORE-BUTTON$ THEN ;

: DISCONNECT ( -- )   CLOSE  IDB_CONNECT RESTORE-BUTTON$
   DISABLE-PUSHBUTTONS  IDB_CONNECT ENABLE-PUSHBUTTON   FALSE CONNECTED ! ;

: CON/DIS ( -- )   CONNECTED @ IF DISCONNECT ELSE CONNECT>SERVER THEN ;


\ --- Top-level client words ---

: RUN-SET-POSITION ( HWND -- )
   DUP IDEF_XPOSFIELD EF-F@  DUP IDEF_YPOSFIELD EF-F@
   DUP IDEF_ALTFIELD  EF-F@      IDEF_PSIFIELD EF-F@  SET-POSITION ;

: SET-FLY-BUTTONS ( -- )   TRIM-RESPONSE TR-TRIM-RESULT @
   IF ENABLE-FLY-BUTTONS ELSE DISABLE-FLY-BUTTONS THEN ;

: RUN-TRIM-ALPHA ( HWND -- )   DUP RUN-SET-POSITION
   IDEF_ALPHAFIELD EF-F@ TRIM-ALPHA  UPDATE-TRIM-FIELDS
   SET-FLY-BUTTONS ;

: RUN-TRIM-SPEED ( HWND -- )   DUP RUN-SET-POSITION
   IDEF_SPEEDFIELD EF-F@ TRIM-SPEED  UPDATE-TRIM-FIELDS
   SET-FLY-BUTTONS ;

: RUN-TRIM-DELE ( HWND -- )   DUP RUN-SET-POSITION
   IDEF_DELEFIELD EF-F@ TRIM-DELE  UPDATE-TRIM-FIELDS
   SET-FLY-BUTTONS ;

: RUN-S/L ( HWND -- )   IDB_S/L TUCK SET-WORKING$ S/L RESTORE-BUTTON$ ;

: RUN-STICK-RAP ( HWND -- )   IDB_STICKRAP TUCK SET-WORKING$ STICK-RAP
   RESTORE-BUTTON$ ;

: RUN-ELEVATOR-DOUBLET ( HWND -- )   IDB_ELEVATORDOUBLET TUCK SET-WORKING$
   ELEVATOR-DOUBLET RESTORE-BUTTON$ ;

: RUN-AILERON-DOUBLET ( HWND -- )   IDB_AILERONDOUBLET TUCK SET-WORKING$
   AILERON-DOUBLET RESTORE-BUTTON$ ;

: RUN-RUDDER-DOUBLET ( HWND -- )   IDB_RUDDERDOUBLET TUCK SET-WORKING$
   RUDDER-DOUBLET RESTORE-BUTTON$ ;

: RUN-LOOP ( HWND -- )   IDB_LOOP TUCK SET-WORKING$ STRAIGHT-LOOP RESTORE-BUTTON$ ;

: RUN-AILERON-ROLL ( HWND -- )   IDB_AILERONROLL TUCK SET-WORKING$
   AILERON-ROLL RESTORE-BUTTON$ ;


\ =============  Event Handlers and Associated Words  ===============

\ About box command handler
: PROCESS-ABOUT-COMMANDS ( hWINDOW,nMSG,wParam,lParam -- Result )
   { hWND MSG wParam lParam }
   wParam LOWORD
   CASE
      IDOK      OF hWND 0 EndDialog DROP 1 ENDOF
      IDCANCEL  OF hWND 0 EndDialog DROP 1 ENDOF
     ( Otherwise)  0 SWAP
   ENDCASE ;

\ About box event handler
: PROCESS-ABOUT ( hWindow,nMsg,nWParam,nLParam -- nResult )
   { hWND MSG WParam LParam }
   MSG CASE
          WM_COMMAND    OF hWND MSG wParam lParam PROCESS-ABOUT-COMMANDS ENDOF
          ( Otherwise...)  0 SWAP
   ENDCASE ;

\ Set the about box event handler
ASSIGN PROCESS-ABOUT TO-CALLBACK AboutDialogProc

: CREATE-ABOUT-BOX ( hWND -- )
   DUP GWL_HINSTANCE GetWindowLong
   IDD_ABOUTDIALOG RESOURCE::GetDialogTemplate
   ROT
   AboutDialogProc
   NULL
   DialogBoxIndirectParam DROP ;

\ Button click event handler
: PROCESS-BUTTON-CLICKS ( hWND,wParam -- t )
   { hWND wParam }
   wParam LOWORD
   CASE
      IDB_CONNECT         OF      CON/DIS              1 ENDOF
      IDB_TRIMALPHA       OF hWND RUN-TRIM-ALPHA       1 ENDOF
      IDB_TRIMSPEED       OF hWND RUN-TRIM-SPEED       1 ENDOF
      IDB_TRIMDELE        OF hWND RUN-TRIM-DELE        1 ENDOF
      IDB_S/L             OF hWND RUN-S/L              1 ENDOF
      IDB_STICKRAP        OF hWND RUN-STICK-RAP        1 ENDOF
      IDB_ELEVATORDOUBLET OF hWND RUN-ELEVATOR-DOUBLET 1 ENDOF
      IDB_AILERONDOUBLET  OF hWND RUN-AILERON-DOUBLET  1 ENDOF
      IDB_RUDDERDOUBLET   OF hWND RUN-RUDDER-DOUBLET   1 ENDOF
      IDB_LOOP            OF hWND RUN-LOOP             1 ENDOF
      IDB_AILERONROLL     OF hWND RUN-AILERON-ROLL     1 ENDOF
      IDM_ABOUT           OF hWND CREATE-ABOUT-BOX     1 ENDOF
      ( Otherwise...)        0 SWAP
   ENDCASE ;

\ The Windows Event Handler.  This handler will be called by the OS.
: PROCESS-EVENT ( hWindow,nMsg,nWParam,nLParam -- nResult )
   { hWND MSG WParam LParam | hDC PS[ PAINTSTRUCT ] RECT[ RECT ] }  \ Create locals.
   MSG CASE
          WM_CREATE  OF hWND CREATE-PUSHBUTTONS
                        hWND CREATE-EDIT-FIELDS&LABELS
                        hWND CREATE-POSITION-FIELDS&LABELS
                        CREATE-STATIC-BRUSH
                        hWND CREATE-TRIM-FIELDS
                        UPDATE-TRIM-FIELDS
                        hWND CREATE-TRIM-BOX
                        hWND CREATE-FLYING-BOX
                        0 ENDOF
          WM_PAINT   OF hWND PS[ BeginPaint TO hDC
                        hWND RECT[ GetClientRect DROP
                        hDC RECT[ hBRUSH_STATIC FillRect DROP
                        hWND PS[ EndPaint DROP
                        0 ENDOF
          WM_COMMAND OF hWND WParam PROCESS-BUTTON-CLICKS
                        ENDOF
          WM_CTLCOLORSTATIC
                     OF WParam SET-STATIC-COLOR
                        hBRUSH_STATIC ENDOF
          WM_CLOSE   OF DISCONNECT
                        hWND DestroyWindow DROP
                        0 ENDOF
          WM_DESTROY OF hBRUSH_STATIC DeleteObject DROP
                        0 PostQuitMessage
                        0 ENDOF
          ( Otherwise...) >R hWND MSG wParam lParam DefWindowProc R>
       ENDCASE ;


\ ========================  Top Level  ==============================

FALSE [IF]    \ Set TRUE to work interactively, FALSE to save exe.

: RUN ( -- )   IDW_MAINWINDOW Resource::CreateParentWindow DUP
   IF   CR ." Demo Window Active, handle = " .
   ELSE DROP HWND_DESKTOP Z" Failed to create demo Window"
        Z" Error"  MB_OK MessageBox DROP
   THEN ;

[ELSE]

: MESSAGE-LOOP ( MsgPtr -- )
   BEGIN
      DUP NULL 0 0 GetMessage
   WHILE
      DUP TranslateMessage DROP
      DUP DispatchMessage DROP
   REPEAT DROP ;

: WINMAIN ( hInstance,hInstance',Cmd,n -- n' )
   { hInstance hInstance' CmdLine CmdShow | msg[ MSG ] }  \ Create locals
   IDW_MAINWINDOW Resource::CreateParentWindow DROP
   msg[ MESSAGE-LOOP   msg[ msg.wParam @ ;

ASSIGN WINMAIN TO-DO ENTRYPOINT

SAVE "Flight Simulation Client"

[THEN]


\ ====================  License Statement  ==========================
\ This program is free software: you can redistribute it and/or modify
\ it under the terms of the GNU General Public License as published by
\ the Free Software Foundation, either version 3 of the License, or
\ (at your option) any later version.
\
\ This program is distributed in the hope that it will be useful,
\ but WITHOUT ANY WARRANTY; without even the implied warranty of
\ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
\ GNU General Public License for more details.
\
\ You should have received a copy of the GNU General Public License
\ along with this program.  If not, see <http://www.gnu.org/licenses/>.
\ ===================================================================