\ ===================================================================
\  File: Data-Values.FTH
\
\  This file creates the data values needed by the simulation client
\  to form command and response messages.  Messages are set up using
\  structures.  (In VFX the fields within structures are contiguous
\  in memory.)  The structure name returns the size of the structure,
\  which is then used to create a buffer.  Each of the fields in
\  the structure provides an offset into the buffer where the field
\  data is located.
\
\              Copyright (C) 2014 Richard C. Wagner
\  This file is offered under the GNU General Public License.
\  Please see the license statement at the end of the file.
\ ===================================================================

\ =======================  Command Values  ==========================

0 CONSTANT HELLO(CMD)
1 CONSTANT ADVANCE(CMD)
2 CONSTANT TRIM(CMD)


\ =====================  Trim Strategy Values  ======================

0 CONSTANT BY-ALPHA
1 CONSTANT BY-SPEED
2 CONSTANT BY-DELE


\ =======================  Hello Command  ===========================

\ Hello command fields
STRUCT HELLO-CMD-FIELDS
   1 CELLS FIELD HC-COMMAND-VALUE
END-STRUCT

\ Hello command message buffer
HELLO-CMD-FIELDS BUFFER: HELLO-COMMAND


\ =======================  Hello Response  ==========================

\ Hello response fields
STRUCT HELLO-RESP-FIELDS
   1 CELLS FIELD HR-COMMAND-VALUE
   1 CELLS FIELD HR-SECONDS
   1 CELLS FIELD HR-MINUTES
   1 CELLS FIELD HR-HOURS
   1 CELLS FIELD HR-DAY
   1 CELLS FIELD HR-MONTH
   1 CELLS FIELD HR-YEAR
END-STRUCT

\ Hello response message buffer
HELLO-RESP-FIELDS BUFFER: HELLO-RESPONSE


\ =======================  Advance Command  =========================

\ Advance command fields
STRUCT ADVANCE-CMD-FIELDS
   1 CELLS   FIELD AC-COMMAND-VALUE
   1 DFLOATS FIELD AC-ADVANCE-TIME
   1 DFLOATS FIELD AC-DELA
   1 DFLOATS FIELD AC-DELE
   1 DFLOATS FIELD AC-DELR
   1 DFLOATS FIELD AC-THROTTLE
END-STRUCT

\ Advance command message buffer
ADVANCE-CMD-FIELDS BUFFER: ADVANCE-COMMAND


\ ======================  Advance Response  =========================

\ Advance response fields
STRUCT ADVANCE-RESP-FIELDS
   1 CELLS   FIELD AR-COMMAND-VALUE
   1 DFLOATS FIELD AR-SimTime
   1 DFLOATS FIELD AR-u
   1 DFLOATS FIELD AR-v
   1 DFLOATS FIELD AR-w
   1 DFLOATS FIELD AR-p
   1 DFLOATS FIELD AR-q
   1 DFLOATS FIELD AR-r
   1 DFLOATS FIELD AR-Psi
   1 DFLOATS FIELD AR-Theta
   1 DFLOATS FIELD AR-Phi
   1 DFLOATS FIELD AR-x
   1 DFLOATS FIELD AR-y
   1 DFLOATS FIELD AR-Altitude
   1 DFLOATS FIELD AR-Alpha
   1 DFLOATS FIELD AR-Beta
   1 DFLOATS FIELD AR-Gamma
   1 DFLOATS FIELD AR-du/dt
   1 DFLOATS FIELD AR-dv/dt
   1 DFLOATS FIELD AR-dw/dt
   1 DFLOATS FIELD AR-dp/dt
   1 DFLOATS FIELD AR-dq/dt
   1 DFLOATS FIELD AR-dr/dt
   1 DFLOATS FIELD AR-dPsi/dt
   1 DFLOATS FIELD AR-dTheta/dt
   1 DFLOATS FIELD AR-dPhi/dt
   1 DFLOATS FIELD AR-dx/dt
   1 DFLOATS FIELD AR-dy/dt
   1 DFLOATS FIELD AR-dz/dt
   1 DFLOATS FIELD AR-delA
   1 DFLOATS FIELD AR-delE
   1 DFLOATS FIELD AR-delR
   1 DFLOATS FIELD AR-Thrust
   1 DFLOATS FIELD AR-Power
   1 DFLOATS FIELD AR-Throttle
END-STRUCT

\ Advance response message buffer
ADVANCE-RESP-FIELDS BUFFER: ADVANCE-RESPONSE


\ ========================  Trim Command  ===========================

\ Trim command fields
STRUCT TRIM-CMD-FIELDS
   1 CELLS   FIELD TC-COMMAND-VALUE
   1 CELLS   FIELD TC-TRIM-STRATEGY
   1 DFLOATS FIELD TC-ALPHA
   1 DFLOATS FIELD TC-SPEED
   1 DFLOATS FIELD TC-DELE
   1 DFLOATS FIELD TC-X
   1 DFLOATS FIELD TC-Y
   1 DFLOATS FIELD TC-Z
   1 DFLOATS FIELD TC-Psi
END-STRUCT

\ Trim command message buffer
TRIM-CMD-FIELDS BUFFER: TRIM-COMMAND


\ ========================  Trim Response  ==========================

\ Trim response fields
STRUCT TRIM-RESP-FIELDS
   1 CELLS   FIELD TR-COMMAND-VALUE
   1 CELLS   FIELD TR-TRIM-RESULT
   1 DFLOATS FIELD TR-ALPHA
   1 DFLOATS FIELD TR-BETA
   1 DFLOATS FIELD TR-SPEED
   1 DFLOATS FIELD TR-delA
   1 DFLOATS FIELD TR-delE
   1 DFLOATS FIELD TR-delR
   1 DFLOATS FIELD TR-THRUST
   1 DFLOATS FIELD TR-POWER
   1 DFLOATS FIELD TR-THROTTLE
END-STRUCT

\ Trim response message buffer
TRIM-RESP-FIELDS BUFFER: TRIM-RESPONSE


\ ====================  License Statement  ==========================
\ This program is free software: you can redistribute it and/or modify
\ it under the terms of the GNU General Public License as published by
\ the Free Software Foundation, either version 3 of the License, or
\ (at your option) any later version.
\
\ This program is distributed in the hope that it will be useful,
\ but WITHOUT ANY WARRANTY; without even the implied warranty of
\ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
\ GNU General Public License for more details.
\
\ You should have received a copy of the GNU General Public License
\ along with this program.  If not, see <http://www.gnu.org/licenses/>.
\ ===================================================================